/* Configure Timidity++ for OS/2. */

config_h='config.h'
timi_make='timidity\Makefile'
EMXIncTest='os2emx.h'
TlkIncTest='bsedos.h'
EMXLibTest='emxio.a'
string_h='string.h'

say '*** ConfigOS/2: Checking/Setting OS/2 environment'

/* Locate EMX include, Warp Toolkit include and EMX library directories */
EMXInc=EScan('C_INCLUDE_PATH',EMXIncTest)
if EMXInc='' then EMXInc=EScan('CPLUS_INCLUDE_PATH',EMXIncTest)
if EMXInc='' then EMXInc=EScan('INCLUDE',EMXIncTest)
if EMXInc='' then do
   say 'Unable to determine EMX include directory'
   exit(1)
   end
TlkInc=EScan('C_INCLUDE_PATH',TlkIncTest)
if TlkInc='' then TlkInc=EScan('CPLUS_INCLUDE_PATH',TlkIncTest)
if TlkInc='' then TlkInc=EScan('INCLUDE',TlkIncTest)
if TlkInc='' then do
   say 'Unable to determine Warp Toolkit include directory'
   exit(1)
   end
EMXLib=EScan('LIBRARY_PATH',EMXLibTest)
if EMXLib='' then EMXLib=EScan('LIBPATH',EMXLibTest)
if EMXLib='' then do
   say 'Unable to determine EMX library directory'
   exit(1)
   end
PatchSTRNCASE='N'
Temp=translate(EMXInc,'\','/')
if right(Temp,1)<>'\' then Temp=Temp'\'
Temp=insert(Temp,string_h)
if stream(Temp,'c','query exists')='' then do
   say 'File not found:' Temp
   exit(1)
   end
do while chars(Temp)<>0
   Next=linein(Temp)
   if (word(Next,1)='#define')&(word(Next,2)='strncasecmp') then PatchSTRNCASE='Y'
   end
call stream Temp,'c','close'

call value 'C_INCLUDE_PATH',EMXInc,'OS2ENVIRONMENT'
call value 'CPLUS_INCLUDE_PATH',EMXInc,'OS2ENVIRONMENT'
call value 'LIBRARY_PATH',EMXLib,'OS2ENVIRONMENT'
call value 'GCCOPT','-pipe','OS2ENVIRONMENT'

/*say 'EMXInc:' EMXInc
say 'TlkInc:' TlkInc
say 'EMXLib:' EMXLib
say 'Need HAVE_STRNCASECMP patch:' PatchSTRNCASE
exit(0)*/

say '*** ConfigOS/2: Running configure script'

'@bash configure --disable-esdtest --disable-alsatest --disable-gtktest --host=i586-linux'

if PatchSTRNCASE='Y' then do
   say '*** ConfigOS/2: Patching' config_h

   if (stream(config_h,'c','query exists')='') then do
      say 'File not found:' config_h
      exit(1)
      end
   Temp=config_h'~'
   '@if exist' Temp 'del' Temp
   do while chars(config_h)<>0
      Next=linein(config_h)
      if (word(Next,1)='/*')&(word(Next,2)='#undef')&(word(Next,3)='HAVE_STRNCASECMP')&(word(Next,4)='*/') then
         Next='#define HAVE_STRNCASECMP 1'
      call lineout Temp,Next
      end
   call stream config_h,'c','close'
   call stream Temp,'c','close'
   '@copy' Temp config_h'>nul'
   '@del' Temp
   end

say '*** ConfigOS/2: Patching' timi_make

if (stream(timi_make,'c','query exists')='') then do
   say 'File not found:' timi_make
   exit(1)
   end
Temp=timi_make'~'
'@if exist' Temp 'del' Temp
do while chars(timi_make)<>0
   Next=linein(timi_make)
   if (word(Next,1)='SYSEXTRAS')&(word(Next,2)='=') then
      Next='SYSEXTRAS = dart_a.c'
   else if (word(Next,1)='CPPFLAGS')&(word(Next,2)='=') then
      Next='CPPFLAGS = -I'EMXInc '-I'TlkInc '-DAU_DART -DDEFAULT_PATH=\"./\"'
   else if (word(Next,1)='LIBS')&(word(Next,2)='=') then
      Next='LIBS = -lsocket -lm -los2me'
   else if (word(Next,1)='DEFS')&(word(Next,2)='=') then
      Next='DEFS = -D__EMX__ -DHAVE_CONFIG_H -I. -I$(srcdir) -I.. -I..'
   call lineout Temp,Next
   end
call stream timi_make,'c','close'
call stream Temp,'c','close'
'@copy' Temp timi_make'>nul'
'@del' Temp

say '*** ConfigOS/2: Configuration complete'
exit(0)

/* Scan environment var arg(1) for a directory with file arg(2) */
EScan:
   procedure
   var=value(arg(1),,'OS2ENVIRONMENT')
   file=arg(2)
   ret=''
   do while (var<>'')&(ret='')
      if pos(';',var)<>0 then do
         dir=left(var,pos(';',var)-1)
         var=substr(var,pos(';',var)+1)
         end
      else do
         dir=var
         var=''
         end
      dir=translate(strip(dir),'\','/')
      do while pos(':',dir)<>0
         dir=substr(dir,pos(':',dir)+1)
         end
      if dir<>'' then do
         if right(dir,1)<>'\' then dir=dir'\'
         if stream(insert(dir,file),'c','query exists')<>'' then ret=dir
         end
      end
   if length(ret)>1 then if right(ret,1)='\' then ret=left(ret,length(ret)-1)
   return translate(ret,'/','\')

